import pygame
import random
import usb
import board

class myCar:
    def __init__(self,surface):
        self.surface = surface
        self.s = board.Board()
        self.x = surface.get_width()/2
        self.y = surface.get_height()-350
        self.vx = 0
        self.vy = 0

    def event2(self):
        get = self.s.get_light()
        if (score > 5000):
            self.x = float(get)**0.5*70-1500
        else:
            if (get > 750):
                self.vx += 0.15
            elif (get > 591):
                self.vx += 0.05
            elif (533 <= self.s.get_light() <= 591):
                self.vx += 0
            #if (self.vx > 0):
             #   self.vx -= 0.1
            #if (self.vx < 0):
             #   self.vx += 0.1
            elif (get > 517):
                self.vx -= 0.05
            else:
                self.vx -= 0.15

    def event(self, event, spd):
        if event.key == pygame.K_UP:
            self.vx = 0
            self.vy = -30
        elif event.key == pygame.K_DOWN:
            self.vx = 0
            self.vy = 30
        elif event.key == pygame.K_LEFT:
            self.vx = -30
            self.vy = 0
        elif event.key == pygame.K_RIGHT:
            self.vx = 30
            self.vy = 0
        car.move()

    def draw(self):
        if (score < 3000):
            screen.blit(piccar, (self.x,self.y))
        elif (score < 5000):
            screen.blit(piccar4, (self.x,self.y))
        else:
            screen.blit(piccar3, (self.x,self.y))

    def crash(self):
        if self.x < 100 or self.x > 800:
            return True
        
    def move(self):
        if self.x <= 50:
            self.x = 50
        if self.x >= 700:
            self.x = 700
        if (score < 3000):
            if self.vx <= -3:
                self.vx = -3
            if self.vx >= 3:
                self.vx = 3
        elif (score < 5000):
            if self.vx <= -5:
                self.vx = -5
            if self.vx >= 5:
                self.vx = 5
        self.x += self.vx
        #self.y += self.vy

class Car:
    def __init__(self,v):
        self.x = random.randint(110,800)
        self.y = -400
        self.vy = v

    def draw(self):
        screen.blit(piccar2, (self.x,self.y))

    def move(self):
        self.y += self.vy
        if self.y > 800:
            self.y = -800
            self.x = random.randint(110,800)
            self.vy += 0.15

    def crash(self):
        if self.x <= car.x <= self.x+100 and self.y <= car.y <= self.y+202:
            return True
        if self.x <= car.x+90 <= self.x+100 and self.y <= car.y+200 <= self.y+202:
            return True
        if self.x <= car.x+45 <= self.x+100 and self.y <= car.y+100 <= self.y+202:
            return True
class item:
    def __init__(self):
        self.x = random.randint(110,700)
        self.y = -4000
        self.vy = 4
    def draw(self):
        screen.blit(heart, (self.x,self.y))
    def move(self):
        self.y += self.vy
        if self.y > 800:
            self.y = -7500
            self.x = random.randint(110,700)
            self.vy += 0.15
    def get(self):
        if self.x <= car.x <= self.x+80 and self.y <= car.y <= self.y+74:
            return True
        if self.x <= car.x+90 <= self.x+80 and self.y <= car.y+200 <= self.y+74:
            return True
        if self.x <= car.x+45 <= self.x+80 and self.y <= car.y+100 <= self.y+74:
            return True

SCREEN_WIDTH, SCREEN_HEIGHT = 800, 800
screen = pygame.display.set_mode((SCREEN_WIDTH,SCREEN_HEIGHT))
clock = pygame.time.Clock()
background = pygame.image.load('road.jpg').convert_alpha()
intro = pygame.image.load('intro.jpg').convert_alpha()
intro2 = pygame.image.load('intro2.jpg').convert_alpha()
intro3 = pygame.image.load('intro3.jpg').convert_alpha()
piccar = pygame.image.load('car.png').convert_alpha()
piccar2 = pygame.image.load('car2.png').convert_alpha()
piccar3 = pygame.image.load('car3.png').convert_alpha()
piccar4 = pygame.image.load('car4.png').convert_alpha()
heart = pygame.image.load('heart.png').convert_alpha()
Bomb = pygame.image.load('Boom.png').convert_alpha()
pygame.mixer.init()
bgm = pygame.mixer.Sound('DriverHigh.ogg')
BombS = pygame.mixer.Sound('explode_1.wav')
car = myCar(screen)
car2 = Car(3)
car3 = Car(5)
car4 = Car(7)
heart1 = item()
pos = -800
spd = 5
running = True
pygame.font.init()
font = pygame.font.Font(None, 60)
first = True
crash = 0
score = 0
#Intro
screen.blit(intro, (0,-70))
pygame.display.flip()
pygame.time.delay(2000)
screen.blit(intro2, (0,-70))
pygame.display.flip()
pygame.time.delay(1000)
screen.blit(intro3, (0,-70))
pygame.display.flip()
pygame.time.delay(3000)
bgm.play(-1)

while running:  
    #wait Key to Start Game
    while first:
        screen.blit(background, (0,pos))
        text = font.render("Please Enter to Start Game", 1, (0, 0, 0))
        screen.blit(text, (170,320))
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                first = False
                running = False
                break
            elif event.type == pygame.KEYDOWN:
                first = False
                crash = 0
                score = 0
                pos = -800
                spd = 5
                car2.vy=3
                car3.vy=5
                car4.vy=7
                heart1.vy=4
                    
                if event.key == pygame.K_UP:
                    crash = -99
        pygame.display.flip()
    if (pos > -100):
        pos = -800
        spd += 0.05
    screen.blit(background, (0,pos))
    text = font.render("HP", 1, (255, 255, 255))
    screen.blit(text, (10,330))
    sscore = font.render("Score", 1, (0, 0, 255))
    screen.blit(sscore, (15,100))
    ssscore = font.render("%d" %score, 1, (0, 0, 255))
    screen.blit(ssscore, (15,200))
    #Show Heart
    if crash <= 0:
        screen.blit(heart, (20,400))
        screen.blit(heart, (20,500))
        screen.blit(heart, (20,600))
    elif crash == 1:
        screen.blit(heart, (20,400))
        screen.blit(heart, (20,500))
    elif crash == 2:
        screen.blit(heart, (20,400))
    elif crash == 3:
        if score < 3000:
            text = font.render("Kak Jung", 1, (255, 255, 0))
        elif score < 5000:
            text = font.render("Good", 1, (255, 255, 0))
        elif score >= 5000:
            text = font.render("Excellent !!!", 1, (255, 255, 0))        
        screen.blit(text, (200,320))
        pygame.display.flip()
        pygame.time.delay(1000)
        text = font.render("Please Try Again", 1, (255, 255, 0))
        screen.blit(text, (200,380))
        pygame.display.flip()
        pygame.time.delay(1000)
        #HighScore
        scorefile = open('score','r')
        savedscore = scorefile.readlines()
        savedscore = int(savedscore[0])
        highscore = font.render('High Score : %d' %savedscore, 1, (255, 255, 255))
        screen.blit(highscore, (400,500))
        pygame.display.flip()
        pygame.time.delay(1000)
        if score > savedscore:
            scorefile = open('score','w')            
            scorefile.write(str(score))
            highscore = font.render('Your Score is new high score: %d' %score, 1, (255, 255, 255))
            screen.blit(highscore, (50,630))
            pygame.display.flip()
            pygame.time.delay(3000)
        first = True
    #Check Car Crash
    if car.crash() or car2.crash() or car3.crash() or car4.crash():
        BombS.play(0)
        screen.blit(Bomb,(car.x,car.y))
        pygame.display.flip()
        if car.crash():
            car.x = 370
        car2.y += 4000
        car3.y += 4000
        car4.y += 4000
        pygame.time.delay(2000)
        crash += 1
    if heart1.get():
        if(0 < crash <3):
            crash -= 1
        heart1.y += 4000   
    else:
        score += 1
        pos += spd
        if (score > 2500):
            car3.draw()            
            car3.move()
        if (score > 6500):
            car4.draw()
            car4.move()        
        heart1.draw()
        heart1.move()        
        car.draw()
        car2.draw()
        car2.move()
        car.event2()
        car.move()
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        elif event.type == pygame.KEYDOWN:
            car.event(event, spd)
    pygame.display.flip()
    clock.tick(80)
